;--------------------------------------------------------------------
; vcomslnk.asm - Virtual Pro Comms Link Driver
;                       for Printer Port Adapter  Version 1.0
;        Copyright 2002 Takashi Yano  <takashi.yano@nifty.ne.jp>
;        Last Modified  Oct.14, 2002
;--------------------------------------------------------------------

	.386p
WIN40COMPAT	EQU	1	; for Windows95 compatibility

;---------------------------------------------------------------
;include files
;---------------------------------------------------------------    
                include vmm.inc

;---------------------------------------------------------------
;    Virtual Device Declaration
;---------------------------------------------------------------    
VCOMSLNK_VER_HI  EQU     1
VCOMSLNK_VER_LO  EQU     0

Declare_Virtual_Device \
	VCOMSLNK, \
	VCOMSLNK_VER_HI, VCOMSLNK_VER_LO, \
	VCOMSLNK_Control, \
	Undefined_Device_ID, Undefined_Init_Order

;---------------------------------------------------------------
;    Local Data
;---------------------------------------------------------------    
VxD_LOCKED_DATA_SEG
exstand_virtual_port	dd	310h	; ProCommsLink Port No.
exstand_target_port	dd	378h	; LPT1 Port No.
freewing_virtual_port	dd	320h	; ProCommsLink Port No.
freewing_target_port	dd	378h	; LPT1 Port No.
VxD_LOCKED_DATA_ENDS

;---------------------------------------------------------------
;    Locked Code
;---------------------------------------------------------------    
VxD_LOCKED_CODE_SEG

BeginProc VCOMSLNK_Control
	Control_Dispatch Device_Init, VCOMSLNK_Device_Init
	clc
	ret
EndProc VCOMSLNK_Control

VxD_LOCKED_CODE_ENDS


;---------------------------------------------------------------
;    Initialization  Code
;---------------------------------------------------------------    
VxD_ICODE_SEG

BeginProc VCOMSLNK_Device_Init
	; configuration for ExSTAND I/F
	; Get VirtualPort No.
	mov	eax, exstand_virtual_port
	mov	edi, OFFSET32 exstand_virtual_str
	xor	esi, esi	; [386Enh] section
	VMMCall	Get_Profile_Hex_Int
	jc	VCOMSLNK_Device_Init_Next1
	mov	exstand_virtual_port, eax
	; Get TargetPort No.
	mov	eax, exstand_target_port
	mov	edi, OFFSET32 exstand_target_str
	xor	esi, esi	; [386Enh] section
	VMMCall	Get_Profile_Hex_Int
	mov	exstand_target_port, eax
	; register I/O Handler for ExSTAND I/F
	mov	esi, ExSTAND_DataPort_Handler
	mov	edx, exstand_virtual_port
	VMMCall	Install_IO_Handler
	mov	esi, ExSTAND_StatPort_Handler
	mov	edx, exstand_virtual_port
	add	edx, 2
	VMMCall	Install_IO_Handler
VCOMSLNK_Device_Init_Next1:
	; configuration for FreeWing I/F
	; Get VirtualPort No.
	mov	eax, freewing_virtual_port
	mov	edi, OFFSET32 freewing_virtual_str
	xor	esi, esi	; [386Enh] section
	VMMCall	Get_Profile_Hex_Int
	jc	VCOMSLNK_Device_Init_Next2
	mov	freewing_virtual_port, eax
	; Get TargetPort No.
	mov	eax, freewing_target_port
	mov	edi, OFFSET32 freewing_target_str
	xor	esi, esi	; [386Enh] section
	VMMCall	Get_Profile_Hex_Int
	mov	freewing_target_port, eax
	; register I/O Handler for FreeWing I/F
	mov	esi, FreeWing_DataPort_Handler
	mov	edx, freewing_virtual_port
	VMMCall	Install_IO_Handler
	mov	esi, FreeWing_StatPort_Handler
	mov	edx, freewing_virtual_port
	add	edx, 2
	VMMCall	Install_IO_Handler
VCOMSLNK_Device_Init_Next2:
	clc
	ret
EndProc VCOMSLNK_Device_Init

VxD_ICODE_ENDS

;---------------------------------------------------------------
;    Code Segment
;---------------------------------------------------------------    
VxD_CODE_SEG

;-------------------------------------
; for ExSTAND Parallel I/F
;-------------------------------------
EXSTAND_DFLT	EQU	00H
EXSTAND_STB_L	EQU	01H	; STROBE#
EXSTAND_INP	EQU	20H	; MODE I/O
EXSTAND_OE	EQU	02H	; AUTO_FD#
EXSTAND_ACK_L	EQU	80H	; BUSY

;----- I/O Handler for Data Port -----

unsigned char tmp;
unsigned char read_tmp;

BeginProc ExSTAND_DataPort_Handler
	test	cl, String_IO
	jnz	VCOMSLNK_Simulate_IO
	cmp	cl, Byte_Input
	je	ExSTAND_DataPort_Handler_InB
	cmp	cl, Byte_Output
	jne	VCOMSLNK_Simulate_IO
ExSTAND_DataPort_Handler_OutB:
	push	edx
	mov	edx, exstand_target_port
	out	dx, al
tmp = ;
port_write_byte(_port_value+0, tmp);


	inc	edx
	inc	edx
	push	eax
	mov	al, EXSTAND_DFLT OR EXSTAND_STB_L
	out	dx, al
tmp = EXSTAND_DFLT | EXSTAND_STB_L; //0x01
port_write_byte(_port_value+2, tmp);


	mov	al, EXSTAND_DFLT	; STROBE H
	out	dx, al
/* STROBE H */
tmp = EXSTAND_DFLT; //0x00
port_write_byte(_port_value+2, tmp);


	pop	eax
	pop	edx
	ret
ExSTAND_DataPort_Handler_InB:
	push	edx
	mov	edx, exstand_target_port
	inc	edx
	inc	edx
	mov	al, EXSTAND_DFLT OR EXSTAND_INP	; Input mode
	out	dx, al
/* Input mode */
tmp = EXSTAND_DFLT | EXSTAND_INP; // 0x20
port_write_byte(_port_value+2, tmp);


	or	al, EXSTAND_OE ; Output Enable for HC573
	out	dx, al
/* Output Enable for HC573 */
tmp |= EXSTAND_OE; // 0x22
port_write_byte(_port_value+2, tmp);


	mov	edx, exstand_target_port
	in	al, dx
read_tmp = port_read_byte(_port_value+0);


	inc	edx
	inc	edx
	push	eax
	mov	al, EXSTAND_DFLT OR EXSTAND_INP	; Output Disable for HC573
	out	dx, al
/* Output Disable for HC573 */
tmp = EXSTAND_DFLT | EXSTAND_INP;
port_write_byte(_port_value+2, tmp);


	mov	al, EXSTAND_DFLT	; Output mode
	out	dx, al
tmp = EXSTAND_DFLT;
port_write_byte(_port_value+2, tmp);


	pop	eax
	pop	edx
	ret
EndProc ExSTAND_DataPort_Handler

;----- I/O Handler for Status Port -----
BeginProc ExSTAND_StatPort_Handler
	test	cl, String_IO
	jnz	VCOMSLNK_Simulate_IO
	cmp	cl, Byte_Input
	jne	VCOMSLNK_Simulate_IO
	push	edx
	mov	edx, exstand_target_port
	inc	edx
	in	al, dx
read_tmp = port_read_byte(_port_value+1);


	pop	edx
	test	al, EXSTAND_ACK_L	; test ACK
if(read_tmp == EXSTAND_ACK_L)
{
    return 0xFF;
}
return 0xFE;


	jz	ExSTAND_StatPort_Handler_Ack
	mov	al, 0ffH	; report no ACK
	ret
ExSTAND_StatPort_Handler_Ack:
	mov	al, 0feh	; report ACK
	ret
EndProc ExSTAND_StatPort_Handler






;----- Default I/O Handler -----
BeginProc VCOMSLNK_Simulate_IO
	VMMJmp  Simulate_IO
	ret
EndProc VCOMSLNK_Simulate_IO

VxD_CODE_ENDS

	END
