/* 
 * This software is licensed under terms of the GNU GENERAL PUBLIC LICENSE
 *
 * This software is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This software  is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Source code is available at http://ppcenter.free.fr
 */


#ifndef SATCOM_ARP_FOOTER_H
#define SATCOM_ARP_FOOTER_H


/**
 * Bit values for romcode field in footer data.
 * bit0 : if set to 1, can use USB dev cart ROM code.
 * bit1~6 : reserved for future use (if any).
 * bit7 : must all be set to zero. If not set to zero, other bit values will be ignored.
**/
#define ROMCODE_MSK_USB_DEV_CART 0x81
#define ROMCODE_VAL_USB_DEV_CART 0x01


#endif // SATCOM_ARP_FOOTER_H

